<?php

namespace Luticate\Utils;

use Laravel\Lumen\Routing\Controller as BaseController;

class LuController extends BaseController
{
    function execute($businessClass, $businessMethod)
    {
        $reflect = new \ReflectionMethod($businessClass, $businessMethod);
        $params = $reflect->getParameters();

        $args = array();
        foreach ($params as $param) {
            if ($param->isOptional()) {
                $args[$param->getName()] = LuBusiness::getParam($param->getName(), $param->getDefaultValue());
            }
            else {
                $args[$param->getName()] = LuBusiness::checkParam($param->getName());
            }
        }

        return LuOutputFormatter::formatSuccess(forward_static_call_array(array($businessClass, $businessMethod), $args));
    }
}
